#include <stdlib.h>
#include <stdio.h>

#include <X11/Xlib.h>
#include "nagratv.h"

#include "font.h"
        

void DisplayBitmap(DispInfo *d,
                   int x,int y,int xsize,int ysize,
                   unsigned char *bitmap)
{
  int i,j,p,sx;
  unsigned short *dst;

  sx=(xsize+7)/8;
  dst=(unsigned short *)d->base + y*d->width + x;
  for(i=0;i<ysize;i++) {
    for(j=0;j<xsize;j++) {
      p=(bitmap[i*sx+(j>>3)] >> (7-(j & 7))) & 1;
      if (p) p=0x0f30;
      dst[j]=p;
    }
    dst+=d->width;
  }
}

void DisplayText(DispInfo *d,int x,int y,unsigned char *buf,int buf_len)
{
  int i;

  for(i=0;i<buf_len;i++) {
    DisplayBitmap(d,x,y,8,14,&font_bitmap[14*buf[i]]);
    x+=8;
  }
} 

void ClearScreen(DispInfo *d)
{
  int i,s;
  unsigned char *base;

  s=2*d->width*d->height;
  base=d->base;

  for(i=0;i<s;i+=2) *(short *)(base+i)=0;
}

