#include "edge.h"
#include "vcrypt.h"

void edgeCorrection(unsigned char *buffer,int dup_lines)
{
    int i,j,k,s,best_edge_shift=0,edge_position;
    int rsc[384];  /* relative_shift_count */
    int ms[384];   /* mittelung der shift */
    int cp[288];   /* kontrast position innerhalb der zeile */
/*    int cut_bewertung[288];
    int first_cut_line,next_cut_line,start_cut_line,best_cut_bewertung; */

    for(i=0;i<384;i++) rsc[i]=0;
    for(i=0;i<288;i++) rsc[h_offset[i]]++;  /* zaehle wie oft bestimmte offsets auftreten */
    for(i=0;i<384-SKIP;i++)                 /* gleitender durchschnitt ueber rsc */
	{
	    s=0;
	    for(j=-40;j<=40;j++)
		{
		    k=i+j;
		    if (k<0) k=384-SKIP-k;
		    if (k>(383-SKIP)) k=k-(384-SKIP);
		    s=s+rsc[k];
		}
	    ms[i]=s; 
	}
    j=35535;
    for(i=0;i<(384-SKIP);i++) if (ms[i]<j) { best_edge_shift=i; j=ms[i]; }

    edge_position=384-SKIP-best_edge_shift;         /* das ist etwa der rand */
    for(i=0;i<288;i++)  cp[i]=edge_position;

    /* feinjustierung .... */
        
    for(i=0;i<288;i++)
	{
	    rotateFirstHalfLine(&buffer[i*1536],cp[i]-SKIP,0);
	    h_offset[i]=h_offset[i]-(cp[i]-SKIP);
	}
}

void edgeCorrectionFullRes(unsigned char *buffer,int dup_lines)
{
    int i,j,k,s,best_edge_shift=0,edge_position;
    int rsc[384*2];  /* relative_shift_count */
    int ms[384*2];   /* mittelung der shift */
    int cp[288];     /* kontrast position innerhalb der zeile */
/*    int cut_bewertung[288];
    int first_cut_line,next_cut_line,start_cut_line,best_cut_bewertung; */

    for(i=0;i<384*2;i++) rsc[i]=0;
    for(i=0;i<288;i++) rsc[h_offset[i]]++;  /* zaehle wie oft bestimmte offsets auftreten */
    for(i=0;i<(384-SKIP)*2;i++)             /*  gleitender durchschnitt ueber rsc */
	{
	    s=0;
	    for(j=-60;j<=60;j++)
		{
		    k=i+j;
		    if (k<0) k=2*(384-SKIP)-k;
		    if (k>(2*384-1-SKIP)) k=k-2*(384-SKIP);
		    s=s+rsc[k];
		}
	    ms[i]=s; 
	}
    j=35535;
    for(i=0;i<(384-SKIP)*2;i++) if (ms[i]<j) { best_edge_shift=i; j=ms[i]; }

    edge_position=2*(384-SKIP)-best_edge_shift;        /* das ist etwa der rand */
    for(i=0;i<288;i++)  cp[i]=edge_position;

    /* feinjustierung .... */
        
    for(i=0;i<288;i++)
	{
	    rotateFirstHalfLine(&buffer[i*1536*2],cp[i]-SKIP,1);
	    h_offset[i]=h_offset[i]-(cp[i]-SKIP);
	}
}
