#include <sys/time.h>
#include <unistd.h> 
#include "vcrypt.h"
#include "edge.h"

#define USE_ASM_SHIFT

int h_offset[288];

void rotateFirstHalfLine(unsigned char *line,int shift,int fullres)
{
    unsigned char tmp[1536*2];

    if (fullres) {
	if (shift==0) return;

	if (shift>0) { /* nach links */
	    memcpy(tmp,line,1536*2);
	    memcpy(&line[SKIP*4],&tmp[4*SKIP+2*shift],4*(384-SKIP)-2*shift);
	    memcpy(&line[2*384*2-2*shift],&tmp[4*SKIP],2*shift);
	} else {  /* nach rechts */
	    shift=-shift;
	    memcpy(tmp,line,1536*2);
	    memcpy(&line[4*SKIP],&tmp[2*2*384-1-2*shift],2*shift);
	    memcpy(&line[4*SKIP+2*shift],&tmp[4*SKIP],4*(384-SKIP)-2*shift);
	}
    } else {
	if (shift==0) return;

	if (shift>0) { /* nach links */
	    memcpy(tmp,line,1536);
	    memcpy(&line[2*SKIP],&tmp[2*SKIP+2*shift],2*(384-SKIP)-2*shift);
	    memcpy(&line[2*384-2*shift],&tmp[2*SKIP],2*shift);
	} else {  /* nach rechts */
	    shift=-shift;
	    memcpy(tmp,line,1536);
	    memcpy(&line[2*SKIP],&tmp[2*384-1-2*shift],2*shift);
	    memcpy(&line[2*SKIP+2*shift],&tmp[2*SKIP],2*(384-SKIP)-2*shift);
	}
    }
}

void decodeFrameVC(unsigned char *buffer,int dup_lines)
{
    int i,j;

    for(i=0;i<288;i++) h_offset[i]=0;

    if (dup_lines==0) {
	for(i=0;i<287;i++) {
#ifdef USE_ASM_SHIFT
 	    j=findShift_small(&buffer[i*1536],&buffer[(i+1)*1536]);
#else
 	    j=findShift(&buffer[i*1536],&buffer[(i+1)*1536],0);
#endif
	    rotateFirstHalfLine(&buffer[(i+1)*1536],j,0);
	    h_offset[i+1]=j;
	}
    } else {
	for(i=0;i<143;i++) {
#ifdef USE_ASM_SHIFT
 	    j=findShift_small(&buffer[2*i*1536],&buffer[2*(i+1)*1536]);
#else
 	    j=findShift(&buffer[2*i*1536],&buffer[2*(i+1)*1536],0);
#endif
	    rotateFirstHalfLine(&buffer[2*(i+1)*1536],j,0);
	    h_offset[2*(i+1)]=j;
	}
    }  
  
    edgeCorrection(buffer,dup_lines); 
}

inline unsigned long int line_diff(unsigned char *bline,unsigned char *line,int width)
{
    unsigned long int s=0,li,bi;
    int k;

    for(k=0;k<width;k+=2) {
	bi=(unsigned long int)bline[2*k];
	li=(unsigned long int)line[2*k];
	s+=(bi-li)*(bi-li); 
    }

    return(s);
}

int findShift(unsigned char *baseline,unsigned char *line,int fullres)
{
    unsigned int k,best_shift=0,bs,step;
    unsigned long int  s,ls;
    unsigned char tbl[1536*2],tl[1536*2];
    int xf=fullres+1;

    memcpy(tbl,&baseline[2*SKIP*xf],2*(384-SKIP)*xf);
    memcpy(tl,     &line[2*SKIP*xf],2*(384-SKIP)*xf);
    memcpy(&tl[2*(384-SKIP)*xf],&line[2*SKIP*xf],2*(384-SKIP)*xf);

    step=8;
    ls=0xffffffff;
    for(k=0;k<(384-SKIP)*xf;k+=step) {
	s=line_diff(tbl,&tl[2*k],(384-SKIP)*xf);
	if (s<ls) { best_shift=k; ls=s; }
    }        

    bs=best_shift;
    if (bs<step) bs=step;
    if (bs>(384-SKIP)*xf-step) bs=(384-SKIP)*xf-step;
    best_shift=0;
    ls=0xffffffff;
    for(k=bs-step;k<bs+step;k++) {
	s=line_diff(tbl,&tl[2*k],(384-SKIP)*xf);
	if (s<ls) { best_shift=k; ls=s; }
    }
    
    return(best_shift);    
}

void decodeFrameVCFullRes(unsigned char *buffer,int dup_lines)
{
    int i,j;

    for(i=0;i<288;i++) h_offset[i]=0;

    for(i=0;i<287;i++) {
#ifdef USE_ASM_SHIFT
 	j=findShift_full(&buffer[i*1536*2],&buffer[(i+1)*1536*2]);
#else
 	j=findShift(&buffer[i*1536*2],&buffer[(i+1)*1536*2],1);
#endif
	rotateFirstHalfLine(&buffer[(i+1)*1536*2],j,1);
	h_offset[i+1]=j;
    }
  
    edgeCorrectionFullRes(buffer,dup_lines); 
}
